Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 486)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 493)
@@ -73,6 +73,6 @@
     CHARACTER (LEN=25) ::  section_chr
     CHARACTER (LEN=50) ::  rtext
-    INTEGER ::  av, ngp, file_id, i, if, is, j, k, l, layer_xy, n, psi, s, &
-                sender, &
+    INTEGER ::  av, ngp, file_id, i, if, is, iis, j, k, l, layer_xy, n, psi, &
+                s, sender, &
                 ind(4)
     LOGICAL ::  found, resorted, two_d
@@ -110,7 +110,11 @@
           ALLOCATE( level_z(0:nzt+1), local_2d(nxl-1:nxr+1,nys-1:nyn+1) )
 
-#if defined( __netcdf )
-          IF ( myid == 0  .AND.  netcdf_output )  CALL check_open( 101+av*10 )
-#endif
+!
+!--       Classic and 64bit offset NetCDF output is done only on PE0.
+!--       netCDF4/HDF5 output is done in parallel on all PEs.
+          IF ( netcdf_output .AND. ( myid == 0 .OR. netcdf_data_format > 2 ) ) &
+          THEN
+             CALL check_open( 101+av*10 )
+          ENDIF
 
           IF ( data_output_2d_on_each_pe )  THEN
@@ -130,7 +134,11 @@
           ALLOCATE( local_2d(nxl-1:nxr+1,nzb:nzt+1) )
 
-#if defined( __netcdf )
-          IF ( myid == 0  .AND.  netcdf_output )  CALL check_open( 102+av*10 )
-#endif
+!
+!--       Classic and 64bit offset NetCDF output is done only on PE0.
+!--       netCDF4/HDF5 output may be done in parallel on all PEs.
+          IF ( netcdf_output .AND. ( myid == 0 .OR. netcdf_data_format > 2 ) ) &
+          THEN
+             CALL check_open( 102+av*10 )
+          ENDIF
 
           IF ( data_output_2d_on_each_pe )  THEN
@@ -150,7 +158,11 @@
           ALLOCATE( local_2d(nys-1:nyn+1,nzb:nzt+1) )
 
-#if defined( __netcdf )
-          IF ( myid == 0  .AND.  netcdf_output )  CALL check_open( 103+av*10 )
-#endif
+!
+!--       Classic and 64bit offset NetCDF output is done only on PE0.
+!--       netCDF4/HDF5 output may be done in parallel on all PEs.
+          IF ( netcdf_output .AND. ( myid == 0 .OR. netcdf_data_format > 2 ) ) &
+          THEN
+             CALL check_open( 103+av*10 )
+          ENDIF
 
           IF ( data_output_2d_on_each_pe )  THEN
@@ -603,10 +615,11 @@
 !
 !--                Update the NetCDF xy cross section time axis
-                   IF ( myid == 0 )  THEN
+                   IF ( myid == 0  .OR.  netcdf_data_format > 2 )  THEN
                       IF ( simulated_time /= do2d_xy_last_time(av) )  THEN
                          do2d_xy_time_count(av) = do2d_xy_time_count(av) + 1
                          do2d_xy_last_time(av)  = simulated_time
-                         IF ( .NOT. data_output_2d_on_each_pe  .AND. &
-                              netcdf_output )  THEN
+                         IF ( ( .NOT. data_output_2d_on_each_pe  .AND. &
+                              netcdf_output )  .OR.  netcdf_data_format > 2 ) &
+                         THEN
 #if defined( __netcdf )
                             nc_stat = NF90_PUT_VAR( id_set_xy(av),             &
@@ -615,5 +628,5 @@
                                          start = (/ do2d_xy_time_count(av) /), &
                                                     count = (/ 1 /) )
-                         CALL handle_netcdf_error( 'data_output_2d', 53 )
+                            CALL handle_netcdf_error( 'data_output_2d', 53 )
 #endif
                          ENDIF
@@ -645,91 +658,145 @@
 
 #if defined( __parallel )
-                   IF ( data_output_2d_on_each_pe )  THEN
-!
-!--                   Output of partial arrays on each PE
+                   IF ( netcdf_output  .AND.  netcdf_data_format > 2 )  THEN
+!
+!--                   Output in NetCDF4/HDF5 format.
+!--                   Do not output redundant ghost point data except for the
+!--                   boundaries of the total domain.
+                      IF ( two_d ) THEN
+                         iis = 1
+                      ELSE
+                         iis = is
+                      ENDIF
+
 #if defined( __netcdf )
-                      IF ( netcdf_output  .AND.  myid == 0 )  THEN
-                         WRITE ( 21 )  simulated_time, do2d_xy_time_count(av), &
-                                       av
-                      ENDIF
-#endif
-                      WRITE ( 21 )  nxl-1, nxr+1, nys-1, nyn+1
-                      WRITE ( 21 )  local_2d
-
+                      IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                                 id_var_do2d(av,if),           &
+                                                 local_2d(nxl:nxr+1,nys:nyn),  &
+                                                 start = (/ nxl+1, nys+1, iis, &
+                                                    do2d_xy_time_count(av) /), &
+                                                 count = (/ nxr-nxl+2,         &
+                                                            nyn-nys+1, 1, 1 /) )
+                      ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                                 id_var_do2d(av,if),           &
+                                                 local_2d(nxl:nxr,nys:nyn+1),  &
+                                                 start = (/ nxl+1, nys+1, iis, &
+                                                    do2d_xy_time_count(av) /), &
+                                                 count = (/ nxr-nxl+1,         &
+                                                            nyn-nys+2, 1, 1 /) )
+                      ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                                 id_var_do2d(av,if),           &
+                                                 local_2d(nxl:nxr+1,nys:nyn+1),&
+                                                 start = (/ nxl+1, nys+1, iis, &
+                                                    do2d_xy_time_count(av) /), &
+                                                 count = (/ nxr-nxl+2,          &
+                                                            nyn-nys+2, 1, 1 /) )
+                      ELSE
+                         nc_stat = NF90_PUT_VAR( id_set_xy(av),                &
+                                                 id_var_do2d(av,if),           &
+                                                 local_2d(nxl:nxr,nys:nyn),    &
+                                                 start = (/ nxl+1, nys+1, iis, &
+                                                    do2d_xy_time_count(av) /), &
+                                                 count = (/ nxr-nxl+1,         &
+                                                            nyn-nys+1, 1, 1 /) )
+                      ENDIF
+
+                      CALL handle_netcdf_error( 'data_output_2d', 55 )
+#endif
                    ELSE
-!
-!--                   PE0 receives partial arrays from all processors and then
-!--                   outputs them. Here a barrier has to be set, because
-!--                   otherwise "-MPI- FATAL: Remote protocol queue full" may
-!--                   occur.
-                      CALL MPI_BARRIER( comm2d, ierr )
-
-                      ngp = ( nxr-nxl+3 ) * ( nyn-nys+3 )
-                      IF ( myid == 0 )  THEN
-!
-!--                      Local array can be relocated directly.
-                         total_2d(nxl-1:nxr+1,nys-1:nyn+1) = local_2d
-!
-!--                      Receive data from all other PEs.
-                         DO  n = 1, numprocs-1
-!
-!--                         Receive index limits first, then array.
-!--                         Index limits are received in arbitrary order from
-!--                         the PEs.
-                            CALL MPI_RECV( ind(1), 4, MPI_INTEGER,            &
-                                           MPI_ANY_SOURCE, 0, comm2d, status, &
-                                           ierr )
-                            sender = status(MPI_SOURCE)
+
+                      IF ( data_output_2d_on_each_pe )  THEN
+!
+!--                      Output of partial arrays on each PE
+#if defined( __netcdf )
+                         IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                            WRITE ( 21 )  simulated_time, &
+                                          do2d_xy_time_count(av), av
+                         ENDIF
+#endif
+                         WRITE ( 21 )  nxl-1, nxr+1, nys-1, nyn+1
+                         WRITE ( 21 )  local_2d
+
+                      ELSE
+!
+!--                      PE0 receives partial arrays from all processors and
+!--                      then outputs them. Here a barrier has to be set,
+!--                      because otherwise "-MPI- FATAL: Remote protocol queue
+!--                      full" may occur.
+                         CALL MPI_BARRIER( comm2d, ierr )
+
+                         ngp = ( nxr-nxl+3 ) * ( nyn-nys+3 )
+                         IF ( myid == 0 )  THEN
+!
+!--                         Local array can be relocated directly.
+                            total_2d(nxl-1:nxr+1,nys-1:nyn+1) = local_2d
+!
+!--                         Receive data from all other PEs.
+                            DO  n = 1, numprocs-1
+!
+!--                            Receive index limits first, then array.
+!--                            Index limits are received in arbitrary order from
+!--                            the PEs.
+                               CALL MPI_RECV( ind(1), 4, MPI_INTEGER,    &
+                                              MPI_ANY_SOURCE, 0, comm2d, &
+                                              status, ierr )
+                               sender = status(MPI_SOURCE)
+                               DEALLOCATE( local_2d )
+                               ALLOCATE( local_2d(ind(1):ind(2),ind(3):ind(4)) )
+                               CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp,  &
+                                              MPI_REAL, sender, 1, comm2d,   &
+                                              status, ierr )
+                               total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
+                            ENDDO
+!
+!--                         Output of the total cross-section.
+                            IF ( iso2d_output )  THEN
+                               WRITE (21)  total_2d(0:nx+1,0:ny+1)
+                            ENDIF
+!
+!--                         Relocate the local array for the next loop increment
                             DEALLOCATE( local_2d )
-                            ALLOCATE( local_2d(ind(1):ind(2),ind(3):ind(4)) )
-                            CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp,      &
-                                           MPI_REAL, sender, 1, comm2d,       &
-                                           status, ierr )
-                            total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
-                         ENDDO
-!
-!--                      Output of the total cross-section.
-                         IF ( iso2d_output ) WRITE (21)  total_2d(0:nx+1,0:ny+1)
-!
-!--                      Relocate the local array for the next loop increment
-                         DEALLOCATE( local_2d )
-                         ALLOCATE( local_2d(nxl-1:nxr+1,nys-1:nyn+1) )
+                            ALLOCATE( local_2d(nxl-1:nxr+1,nys-1:nyn+1) )
 
 #if defined( __netcdf )
-                         IF ( netcdf_output )  THEN
-                            IF ( two_d ) THEN
-                               nc_stat = NF90_PUT_VAR( id_set_xy(av),          &
-                                                       id_var_do2d(av,if),     &
+                            IF ( netcdf_output )  THEN
+                               IF ( two_d ) THEN
+                                  nc_stat = NF90_PUT_VAR( id_set_xy(av),       &
+                                                          id_var_do2d(av,if),  &
                                                       total_2d(0:nx+1,0:ny+1), &
                                 start = (/ 1, 1, 1, do2d_xy_time_count(av) /), &
                                                 count = (/ nx+2, ny+2, 1, 1 /) )
-                            ELSE
-                               nc_stat = NF90_PUT_VAR( id_set_xy(av),          &
-                                                       id_var_do2d(av,if),     &
+                               ELSE
+                                  nc_stat = NF90_PUT_VAR( id_set_xy(av),       &
+                                                          id_var_do2d(av,if),  &
                                                       total_2d(0:nx+1,0:ny+1), &
                                start = (/ 1, 1, is, do2d_xy_time_count(av) /), &
                                                 count = (/ nx+2, ny+2, 1, 1 /) )
+                               ENDIF
+                               CALL handle_netcdf_error( 'data_output_2d', 54 )
                             ENDIF
-                            CALL handle_netcdf_error( 'data_output_2d', 54 )
-                         ENDIF
-#endif
-
-                      ELSE
-!
-!--                      First send the local index limits to PE0
-                         ind(1) = nxl-1; ind(2) = nxr+1
-                         ind(3) = nys-1; ind(4) = nyn+1
-                         CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, &
-                                        ierr )
-!
-!--                      Send data to PE0
-                         CALL MPI_SEND( local_2d(nxl-1,nys-1), ngp, MPI_REAL, &
-                                        0, 1, comm2d, ierr )
-                      ENDIF
-!
-!--                   A barrier has to be set, because otherwise some PEs may
-!--                   proceed too fast so that PE0 may receive wrong data on
-!--                   tag 0
-                      CALL MPI_BARRIER( comm2d, ierr )
+#endif
+
+                         ELSE
+!
+!--                         First send the local index limits to PE0
+                            ind(1) = nxl-1; ind(2) = nxr+1
+                            ind(3) = nys-1; ind(4) = nyn+1
+                            CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, &
+                                           comm2d, ierr )
+!
+!--                         Send data to PE0
+                            CALL MPI_SEND( local_2d(nxl-1,nys-1), ngp, &
+                                           MPI_REAL, 0, 1, comm2d, ierr )
+                         ENDIF
+!
+!--                      A barrier has to be set, because otherwise some PEs may
+!--                      proceed too fast so that PE0 may receive wrong data on
+!--                      tag 0
+                         CALL MPI_BARRIER( comm2d, ierr )
+                      ENDIF
+
                    ENDIF
 #else
@@ -752,5 +819,5 @@
                                               count = (/ nx+2, ny+2, 1, 1 /) )
                       ENDIF
-                      CALL handle_netcdf_error( 'data_output_2d', 55 )
+                      CALL handle_netcdf_error( 'data_output_2d', 447 )
                    ENDIF
 #endif
@@ -789,10 +856,12 @@
 !
 !--                Update the NetCDF xz cross section time axis
-                   IF ( myid == 0 )  THEN
+                   IF ( myid == 0  .OR.  netcdf_data_format > 2 )  THEN
+
                       IF ( simulated_time /= do2d_xz_last_time(av) )  THEN
                          do2d_xz_time_count(av) = do2d_xz_time_count(av) + 1
                          do2d_xz_last_time(av)  = simulated_time
-                         IF ( .NOT. data_output_2d_on_each_pe  .AND. &
-                              netcdf_output )  THEN
+                         IF ( ( .NOT. data_output_2d_on_each_pe  .AND.        &
+                              netcdf_output )  .OR.  netcdf_data_format > 2 ) &
+                         THEN
 #if defined( __netcdf )
                             nc_stat = NF90_PUT_VAR( id_set_xz(av),             &
@@ -801,8 +870,9 @@
                                          start = (/ do2d_xz_time_count(av) /), &
                                                     count = (/ 1 /) )
-                             CALL handle_netcdf_error( 'data_output_2d', 56 )
-#endif
-                         ENDIF
-                      ENDIF
+                            CALL handle_netcdf_error( 'data_output_2d', 56 )
+#endif
+                         ENDIF
+                      ENDIF
+
                    ENDIF
 !
